diff mbox

[19/23] xfs: test rmapbt functionality

Message ID 20160209011348.23099.30668.stgit@birch.djwong.org (mailing list archive)
State Not Applicable
Headers show

Commit Message

Darrick J. Wong Feb. 9, 2016, 1:13 a.m. UTC
Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
---
 common/xfs        |   44 ++++++++++++++++++++++
 tests/xfs/233     |   78 ++++++++++++++++++++++++++++++++++++++
 tests/xfs/233.out |    6 +++
 tests/xfs/234     |   89 ++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/234.out |    6 +++
 tests/xfs/235     |  108 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/235.out |   14 +++++++
 tests/xfs/236     |   93 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/236.out |    8 ++++
 tests/xfs/group   |    4 ++
 10 files changed, 450 insertions(+)
 create mode 100644 common/xfs
 create mode 100755 tests/xfs/233
 create mode 100644 tests/xfs/233.out
 create mode 100755 tests/xfs/234
 create mode 100644 tests/xfs/234.out
 create mode 100755 tests/xfs/235
 create mode 100644 tests/xfs/235.out
 create mode 100755 tests/xfs/236
 create mode 100644 tests/xfs/236.out



--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html

Comments

Dave Chinner Feb. 9, 2016, 8:26 a.m. UTC | #1
On Mon, Feb 08, 2016 at 05:13:48PM -0800, Darrick J. Wong wrote:
> Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
> ---
>  common/xfs        |   44 ++++++++++++++++++++++
>  tests/xfs/233     |   78 ++++++++++++++++++++++++++++++++++++++
>  tests/xfs/233.out |    6 +++
>  tests/xfs/234     |   89 ++++++++++++++++++++++++++++++++++++++++++++
>  tests/xfs/234.out |    6 +++
>  tests/xfs/235     |  108 +++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/xfs/235.out |   14 +++++++
>  tests/xfs/236     |   93 ++++++++++++++++++++++++++++++++++++++++++++++
>  tests/xfs/236.out |    8 ++++
>  tests/xfs/group   |    4 ++
>  10 files changed, 450 insertions(+)
>  create mode 100644 common/xfs
>  create mode 100755 tests/xfs/233
>  create mode 100644 tests/xfs/233.out
>  create mode 100755 tests/xfs/234
>  create mode 100644 tests/xfs/234.out
>  create mode 100755 tests/xfs/235
>  create mode 100644 tests/xfs/235.out
>  create mode 100755 tests/xfs/236
>  create mode 100644 tests/xfs/236.out
> 
> 
> diff --git a/common/xfs b/common/xfs
> new file mode 100644
> index 0000000..2d1a76f
> --- /dev/null
> +++ b/common/xfs
> @@ -0,0 +1,44 @@
> +##/bin/bash
> +# Routines for handling XFS
> +#-----------------------------------------------------------------------
> +#  Copyright (c) 2015 Oracle.  All Rights Reserved.
> +#  This program is free software; you can redistribute it and/or modify
> +#  it under the terms of the GNU General Public License as published by
> +#  the Free Software Foundation; either version 2 of the License, or
> +#  (at your option) any later version.
> +#
> +#  This program is distributed in the hope that it will be useful,
> +#  but WITHOUT ANY WARRANTY; without even the implied warranty of
> +#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +#  GNU General Public License for more details.
> +#
> +#  You should have received a copy of the GNU General Public License
> +#  along with this program; if not, write to the Free Software
> +#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
> +#  USA
> +#
> +#  Contact information: Oracle Corporation, 500 Oracle Parkway,
> +#  Redwood Shores, CA 94065, USA, or: http://www.oracle.com/
> +#-----------------------------------------------------------------------
> +
> +_require_xfs_test_rmapbt()
> +{
> +	_require_test
> +
> +	if [ "$(xfs_info "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
> +		_notrun "rmapbt not supported by test filesystem type: $FSTYP"
> +	fi
> +}
> +
> +_require_xfs_scratch_rmapbt()
> +{
> +	_require_scratch
> +
> +	_scratch_mkfs > /dev/null
> +	_scratch_mount
> +	if [ "$(xfs_info "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
> +		_scratch_unmount
> +		_notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
> +	fi
> +	_scratch_unmount
> +}

No, not yet. :)

Wait until I get my "split common/rc" patchset out there, because it
does not require:

> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +. ./common/xfs

This.

And i don't want to have to undo a bunch of stuff in tests yet. Just
lump it all in common/rc for the moment.

> +
> +# real QA test starts here
> +_supported_os Linux
> +_supported_fs xfs
> +_require_xfs_scratch_rmapbt
> +
> +echo "Format and mount"
> +_scratch_mkfs -d size=$((2 * 4096 * 4096)) -l size=4194304 > "$seqres.full" 2>&1
> +_scratch_mount >> "$seqres.full" 2>&1

_scratch_mkfs_sized ?

> +here=`pwd`
> +tmp=/tmp/$$
> +status=1	# failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +    cd /
> +    #rm -f $tmp.*

More random uncommenting needed.

> +
> +echo "Check for damage"
> +umount "$SCRATCH_MNT"
> +_check_scratch_fs
> +
> +# success, all done
> +status=0
> +exit

Cull.

-Dave.
Darrick J. Wong Feb. 10, 2016, 1:07 a.m. UTC | #2
On Tue, Feb 09, 2016 at 07:26:40PM +1100, Dave Chinner wrote:
> On Mon, Feb 08, 2016 at 05:13:48PM -0800, Darrick J. Wong wrote:
> > Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
> > ---
> >  common/xfs        |   44 ++++++++++++++++++++++
> >  tests/xfs/233     |   78 ++++++++++++++++++++++++++++++++++++++
> >  tests/xfs/233.out |    6 +++
> >  tests/xfs/234     |   89 ++++++++++++++++++++++++++++++++++++++++++++
> >  tests/xfs/234.out |    6 +++
> >  tests/xfs/235     |  108 +++++++++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/xfs/235.out |   14 +++++++
> >  tests/xfs/236     |   93 ++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/xfs/236.out |    8 ++++
> >  tests/xfs/group   |    4 ++
> >  10 files changed, 450 insertions(+)
> >  create mode 100644 common/xfs
> >  create mode 100755 tests/xfs/233
> >  create mode 100644 tests/xfs/233.out
> >  create mode 100755 tests/xfs/234
> >  create mode 100644 tests/xfs/234.out
> >  create mode 100755 tests/xfs/235
> >  create mode 100644 tests/xfs/235.out
> >  create mode 100755 tests/xfs/236
> >  create mode 100644 tests/xfs/236.out
> > 
> > 
> > diff --git a/common/xfs b/common/xfs
> > new file mode 100644
> > index 0000000..2d1a76f
> > --- /dev/null
> > +++ b/common/xfs
> > @@ -0,0 +1,44 @@
> > +##/bin/bash
> > +# Routines for handling XFS
> > +#-----------------------------------------------------------------------
> > +#  Copyright (c) 2015 Oracle.  All Rights Reserved.
> > +#  This program is free software; you can redistribute it and/or modify
> > +#  it under the terms of the GNU General Public License as published by
> > +#  the Free Software Foundation; either version 2 of the License, or
> > +#  (at your option) any later version.
> > +#
> > +#  This program is distributed in the hope that it will be useful,
> > +#  but WITHOUT ANY WARRANTY; without even the implied warranty of
> > +#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> > +#  GNU General Public License for more details.
> > +#
> > +#  You should have received a copy of the GNU General Public License
> > +#  along with this program; if not, write to the Free Software
> > +#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
> > +#  USA
> > +#
> > +#  Contact information: Oracle Corporation, 500 Oracle Parkway,
> > +#  Redwood Shores, CA 94065, USA, or: http://www.oracle.com/
> > +#-----------------------------------------------------------------------
> > +
> > +_require_xfs_test_rmapbt()
> > +{
> > +	_require_test
> > +
> > +	if [ "$(xfs_info "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
> > +		_notrun "rmapbt not supported by test filesystem type: $FSTYP"
> > +	fi
> > +}
> > +
> > +_require_xfs_scratch_rmapbt()
> > +{
> > +	_require_scratch
> > +
> > +	_scratch_mkfs > /dev/null
> > +	_scratch_mount
> > +	if [ "$(xfs_info "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
> > +		_scratch_unmount
> > +		_notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
> > +	fi
> > +	_scratch_unmount
> > +}
> 
> No, not yet. :)
> 
> Wait until I get my "split common/rc" patchset out there, because it
> does not require:

Ok, I moved all the common/xfs stuff back to common/rc.

> 
> > +# get standard environment, filters and checks
> > +. ./common/rc
> > +. ./common/filter
> > +. ./common/xfs
> 
> This.
> 
> And i don't want to have to undo a bunch of stuff in tests yet. Just
> lump it all in common/rc for the moment.
> 
> > +
> > +# real QA test starts here
> > +_supported_os Linux
> > +_supported_fs xfs
> > +_require_xfs_scratch_rmapbt
> > +
> > +echo "Format and mount"
> > +_scratch_mkfs -d size=$((2 * 4096 * 4096)) -l size=4194304 > "$seqres.full" 2>&1
> > +_scratch_mount >> "$seqres.full" 2>&1
> 
> _scratch_mkfs_sized ?

Done.
> 
> > +here=`pwd`
> > +tmp=/tmp/$$
> > +status=1	# failure is the default!
> > +trap "_cleanup; exit \$status" 0 1 2 3 15
> > +
> > +_cleanup()
> > +{
> > +    cd /
> > +    #rm -f $tmp.*
> 
> More random uncommenting needed.
> 
> > +
> > +echo "Check for damage"
> > +umount "$SCRATCH_MNT"
> > +_check_scratch_fs
> > +
> > +# success, all done
> > +status=0
> > +exit
> 
> Cull.

Done

--D

> 
> -Dave.
> -- 
> Dave Chinner
> david@fromorbit.com
> 
> _______________________________________________
> xfs mailing list
> xfs@oss.sgi.com
> http://oss.sgi.com/mailman/listinfo/xfs
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/common/xfs b/common/xfs
new file mode 100644
index 0000000..2d1a76f
--- /dev/null
+++ b/common/xfs
@@ -0,0 +1,44 @@ 
+##/bin/bash
+# Routines for handling XFS
+#-----------------------------------------------------------------------
+#  Copyright (c) 2015 Oracle.  All Rights Reserved.
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 2 of the License, or
+#  (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software
+#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+#  USA
+#
+#  Contact information: Oracle Corporation, 500 Oracle Parkway,
+#  Redwood Shores, CA 94065, USA, or: http://www.oracle.com/
+#-----------------------------------------------------------------------
+
+_require_xfs_test_rmapbt()
+{
+	_require_test
+
+	if [ "$(xfs_info "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
+		_notrun "rmapbt not supported by test filesystem type: $FSTYP"
+	fi
+}
+
+_require_xfs_scratch_rmapbt()
+{
+	_require_scratch
+
+	_scratch_mkfs > /dev/null
+	_scratch_mount
+	if [ "$(xfs_info "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
+		_scratch_unmount
+		_notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
+	fi
+	_scratch_unmount
+}
diff --git a/tests/xfs/233 b/tests/xfs/233
new file mode 100755
index 0000000..2e61275
--- /dev/null
+++ b/tests/xfs/233
@@ -0,0 +1,78 @@ 
+#! /bin/bash
+# FS QA Test No. 233
+#
+# Tests xfs_growfs on a rmapbt filesystem
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename "$0"`
+seqres="$RESULT_DIR/$seq"
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -f "$tmp".*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/xfs
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_xfs_scratch_rmapbt
+
+echo "Format and mount"
+_scratch_mkfs -d size=$((2 * 4096 * 4096)) -l size=4194304 > "$seqres.full" 2>&1
+_scratch_mount >> "$seqres.full" 2>&1
+
+testdir="$SCRATCH_MNT/test-$seq"
+rm -rf "$testdir"
+mkdir "$testdir"
+
+echo "Create the original files"
+blksz="$(stat -f "$testdir" -c '%S')"
+_pwrite_byte 0x61 0 $((blksz * 14 + 71)) "$testdir/original" >> "$seqres.full"
+cp -p "$testdir/original" "$testdir/copy1"
+cp -p "$testdir/copy1" "$testdir/copy2"
+
+echo "Grow fs"
+"$XFS_GROWFS_PROG" "$SCRATCH_MNT" 2>&1 |  _filter_growfs >> "$seqres.full"
+_scratch_remount
+
+echo "Create more copies"
+cp -p "$testdir/original" "$testdir/copy3"
+
+xfs_info "$SCRATCH_MNT" >> "$seqres.full"
+
+echo "Check scratch fs"
+umount "$SCRATCH_MNT"
+_check_scratch_fs
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/233.out b/tests/xfs/233.out
new file mode 100644
index 0000000..7a7b991
--- /dev/null
+++ b/tests/xfs/233.out
@@ -0,0 +1,6 @@ 
+QA output created by 233
+Format and mount
+Create the original files
+Grow fs
+Create more copies
+Check scratch fs
diff --git a/tests/xfs/234 b/tests/xfs/234
new file mode 100755
index 0000000..1bdf8b2
--- /dev/null
+++ b/tests/xfs/234
@@ -0,0 +1,89 @@ 
+#! /bin/bash
+# FS QA Test No. 234
+#
+# Ensure that we can create enough distinct rmap entries to force creation
+# of a multi-level rmap btree, and that metadump will successfully copy
+# said block.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+
+seq=`basename "$0"`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    umount "$SCRATCH_MNT" > /dev/null 2>&1
+    rm -rf "$tmp".* "$testdir" "$metadump_file" "$TEST_DIR/image"
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/xfs
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_loop
+_require_xfs_scratch_rmapbt
+_require_xfs_io_command "fpunch"
+
+rm -f "$seqres.full"
+
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount
+
+testdir="$SCRATCH_MNT/test-$seq"
+rm -rf "$testdir"
+mkdir "$testdir"
+metadump_file="$TEST_DIR/${seq}_metadump"
+
+echo "Create the original file blocks"
+blksz="$(stat -f "$testdir" -c '%S')"
+nr_blks=$((4 * blksz / 12))
+_pwrite_byte 0x61 0 $((blksz * nr_blks)) "$testdir/file1" >> "$seqres.full"
+sync
+
+echo "Punch every other block"
+seq 1 2 $((nr_blks - 1)) | while read nr; do
+	"$XFS_IO_PROG" -c "fpunch $((nr * blksz)) $blksz" "$testdir/file1" >> "$seqres.full"
+done
+
+echo "Create metadump file"
+_scratch_unmount
+_scratch_metadump "$metadump_file"
+
+# Now restore the obfuscated one back and take a look around
+echo "Restore metadump"
+xfs_mdrestore "$metadump_file" "$TEST_DIR/image"
+_mount -t $FSTYP "$TEST_DIR/image" "$SCRATCH_MNT"
+umount "$SCRATCH_MNT"
+
+echo "Check restored fs"
+_check_generic_filesystem "$metadump_file"
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/234.out b/tests/xfs/234.out
new file mode 100644
index 0000000..463d466
--- /dev/null
+++ b/tests/xfs/234.out
@@ -0,0 +1,6 @@ 
+QA output created by 234
+Create the original file blocks
+Punch every other block
+Create metadump file
+Restore metadump
+Check restored fs
diff --git a/tests/xfs/235 b/tests/xfs/235
new file mode 100755
index 0000000..4e34d3c
--- /dev/null
+++ b/tests/xfs/235
@@ -0,0 +1,108 @@ 
+#! /bin/bash
+# FS QA Test No. 235
+#
+# Create and populate an XFS filesystem, corrupt the rmap btree,
+# then see how the kernel and xfs_repair deal with it.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Oracle, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-7031  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename "$0"`
+seqres="$RESULT_DIR/$seq"
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    #rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+. ./common/xfs
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_xfs_scratch_rmapbt
+test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
+
+rm -f "$seqres.full"
+
+echo "+ create scratch fs"
+_scratch_mkfs_xfs > /dev/null
+
+echo "+ mount fs image"
+_scratch_mount
+blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
+agcount="$(xfs_info "${SCRATCH_MNT}" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g')"
+
+echo "+ make some files"
+_pwrite_byte 0x62 0 $((blksz * 64)) "${SCRATCH_MNT}/file0" >> "$seqres.full"
+_pwrite_byte 0x61 0 $((blksz * 64)) "${SCRATCH_MNT}/file1" >> "$seqres.full"
+cp -p "${SCRATCH_MNT}/file0" "${SCRATCH_MNT}/file2"
+cp -p "${SCRATCH_MNT}/file1" "${SCRATCH_MNT}/file3"
+umount "${SCRATCH_MNT}"
+
+echo "+ check fs"
+_scratch_xfs_repair -n >> "$seqres.full" 2>&1 || \
+	_fail "xfs_repair should not fail"
+
+echo "+ corrupt image"
+seq 0 $((agcount - 1)) | while read ag; do
+	$XFS_DB_PROG -x -c "agf ${ag}" -c "agf ${ag}" -c "addr rmaproot" \
+		-c "stack" -c "blocktrash -x 4096 -y 4096 -z -n 8 -3" \
+		"${SCRATCH_DEV}" >> "$seqres.full" 2>&1
+done
+
+echo "+ mount image"
+_scratch_mount
+
+echo "+ copy more"
+"$XFS_IO_PROG" -f -c "pwrite -S 0x63 0 $((blksz * 64))" -c "fsync" "${SCRATCH_MNT}/file4" >> "$seqres.full"
+test -s "${SCRATCH_MNT}/file4" || _fail "should not be able to copy with busted rmap btree"
+umount "${SCRATCH_MNT}"
+
+echo "+ repair fs"
+_scratch_xfs_repair >> "$seqres.full" 2>&1
+_scratch_xfs_repair >> "$seqres.full" 2>&1
+
+echo "+ mount image (2)"
+_scratch_mount
+
+echo "+ chattr -R -i"
+chattr -R -f -i "${SCRATCH_MNT}/"
+
+echo "+ copy more (2)"
+cp -p "${SCRATCH_MNT}/file1" "${SCRATCH_MNT}/file5" || \
+	_fail "modified rmap tree"
+umount "${SCRATCH_MNT}"
+
+echo "+ check fs (2)"
+_scratch_xfs_repair -n >> "$seqres.full" 2>&1 || \
+	_fail "xfs_repair should not fail"
+
+status=0
+exit
diff --git a/tests/xfs/235.out b/tests/xfs/235.out
new file mode 100644
index 0000000..89a11d6
--- /dev/null
+++ b/tests/xfs/235.out
@@ -0,0 +1,14 @@ 
+QA output created by 235
++ create scratch fs
++ mount fs image
++ make some files
++ check fs
++ corrupt image
++ mount image
++ copy more
+fsync: Structure needs cleaning
++ repair fs
++ mount image (2)
++ chattr -R -i
++ copy more (2)
++ check fs (2)
diff --git a/tests/xfs/236 b/tests/xfs/236
new file mode 100755
index 0000000..d3a9edc
--- /dev/null
+++ b/tests/xfs/236
@@ -0,0 +1,93 @@ 
+#! /bin/bash
+# FS QA Test No. 236
+#
+# Ensure that we can create enough distinct rmapbt entries to force creation
+# of a multi-level rmap btree.  Delete and recreate a few times to
+# exercise the rmap btree grow/shrink functions.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+
+seq=`basename "$0"`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    umount "$SCRATCH_MNT" > /dev/null 2>&1
+    rm -rf "$tmp".* "$testdir"
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/xfs
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_xfs_scratch_rmapbt
+_require_xfs_io_command "fpunch"
+
+rm -f "$seqres.full"
+
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount
+
+testdir="$SCRATCH_MNT/test-$seq"
+rm -rf "$testdir"
+mkdir "$testdir"
+
+echo "Create the original file blocks"
+blksz="$(stat -f "$testdir" -c '%S')"
+nr_blks=$((8 * blksz / 12))
+
+for i in 1 2 x; do
+	_pwrite_byte 0x61 0 $((blksz * nr_blks)) "$testdir/file1" >> "$seqres.full"
+	_pwrite_byte 0x62 0 $((blksz * nr_blks)) "$testdir/file2" >> "$seqres.full"
+	sync
+
+	echo "$i: Reflink every other block"
+	seq 1 2 $((nr_blks - 1)) | while read nr; do
+		"$XFS_IO_PROG" -c "fpunch $((nr * blksz)) $blksz" "$testdir/file2" >> "$seqres.full"
+	done
+	umount "$SCRATCH_MNT"
+	_check_scratch_fs
+	_scratch_mount
+
+	test "$i" = "x" && break
+
+	echo "$i: Delete both files"
+	rm -rf "$testdir/file1" "$testdir/file2"
+	umount "$SCRATCH_MNT"
+	_check_scratch_fs
+	_scratch_mount
+done
+
+echo "Check for damage"
+umount "$SCRATCH_MNT"
+_check_scratch_fs
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/236.out b/tests/xfs/236.out
new file mode 100644
index 0000000..237a7e1
--- /dev/null
+++ b/tests/xfs/236.out
@@ -0,0 +1,8 @@ 
+QA output created by 236
+Create the original file blocks
+1: Reflink every other block
+1: Delete both files
+2: Reflink every other block
+2: Delete both files
+x: Reflink every other block
+Check for damage
diff --git a/tests/xfs/group b/tests/xfs/group
index de3c7d6..1d08065 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -230,6 +230,10 @@ 
 230 auto quick clone
 231 auto quick clone
 232 auto quick clone
+233 auto quick rmap
+234 auto quick rmap
+235 fuzzers rmap
+236 auto quick rmap
 238 auto quick metadata ioctl
 242 auto quick prealloc
 244 auto quota quick